/**
 * Testet die Operationsverst&auml;rker-Klassen.
 * 
 * @author Owyn
 * @version 2008-06-08
 */
public class OpAmpTest {
    
    /**
     * Erzeugt einige Operationsverst&auml;rker-Objekte und testet deren Methoden.
     */
    public static void test() {
        // Array fuer vier Operationsverstaerker anlegen
        IdealOpAmp[] amps = new IdealOpAmp[4];
        
        // Array initalisieren
        amps[0] = new IdealOpAmp(582.22, 34.12);
        amps[1] = new AdderOpAmp(111.123, 232.54, 321.33);
        amps[2] = new IdealOpAmp();
        amps[3] = new AdderOpAmp();
        
        // Ausgabe
        for (int i = 0; i < amps.length; i++) {
            System.out.print(amps[i]); // toString() wird automatisch aufgerufen
            
            // Ist der dynamische Typ des Array-Elements "AdderOpAmp"?
            if (amps[i] instanceof AdderOpAmp) {
                // Dann TypeCast nach AdderOpAmp und AdderMode ausgeben
                System.out.print(", AdderMode: " + ((AdderOpAmp) amps[i]).adderMode());
            }
            
            System.out.println();
        }
        
    	// Berechnungsbeispiel
        System.out.println("Compute UO: " + ((AdderOpAmp) amps[3]).computeOutput(12.3, 40.7));
	}
    
}